SystemOrganization addCategory: #'ExifTool-Core'!

Object subclass: #ETExif
	instanceVariableNames: 'file properties'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ExifTool-Core'!

!ETExif commentStamp: 'FrancoisStephany 11/19/2011 12:59' prior: 0!
This package wraps the perl library 'ExifTool'.
http://www.sno.phy.queensu.ca/~phil/exiftool/!

!ETExif methodsFor: 'accessing' stamp: 'FrancoisStephany 11/24/2011 17:09'!
buildCommand
	" complete reference: http://www.sno.phy.queensu.ca/~phil/exiftool/exiftool_pod.html
	-j json output
	 -E escapes HTML characters
	-L uses latin1
	-w EXT : save in a file with the given extension"
	^ 'exiftool -j -w txt ' , self file fullName! !

!ETExif methodsFor: 'executing' stamp: 'FrancoisStephany 11/24/2011 16:56'!
deleteOutputFile
	self outputFile delete.! !

!ETExif methodsFor: 'accessing' stamp: 'FrancoisStephany 11/19/2011 13:00'!
file
	^ file! !

!ETExif methodsFor: 'accessing' stamp: 'FrancoisStephany 11/19/2011 13:00'!
file: anObject
	file := anObject! !

!ETExif methodsFor: 'accessing' stamp: 'FrancoisStephany 11/24/2011 17:12'!
outputFile
	^self file parent / (self file base , '.txt')! !

!ETExif methodsFor: 'accessing' stamp: 'FrancoisStephany 11/24/2011 18:04'!
properties
	^ properties ifNil: [properties := Dictionary new]! !

!ETExif methodsFor: 'accessing' stamp: 'FrancoisStephany 11/19/2011 13:17'!
properties: anObject
	properties := anObject! !

!ETExif methodsFor: 'executing' stamp: 'FrancoisStephany 11/24/2011 18:06'!
readPropertiesFromFile:  aFileReference
	| jsonString byteArray capitalizedProperties |
	byteArray := aFileReference readStream contents.
	jsonString := GRPharoUtf8Codec new decode: byteArray.
	capitalizedProperties := (Json readFrom: jsonString readStream) first.
	capitalizedProperties keysAndValuesDo: [:key :value |
		self properties 
			at: key asLegalSelector asSymbol 
			put: value ].! !

!ETExif methodsFor: 'executing' stamp: 'FrancoisStephany 11/24/2011 17:53'!
run
	| resultString path env |
	self file isFile ifFalse: [ self error: 'You must specify the picture file' ].
	
	env := OSProcess thisOSProcess environment copy.
	path := (env at: #PATH), ':/usr/local/bin/'.
	env at: #PATH put: path.

	resultString := (PipeableOSProcess command: self buildCommand environment: env) output.
	self outputFile exists 
		ifTrue: [
			self readPropertiesFromFile: self outputFile.
			self deleteOutputFile ]
		ifFalse: [ self error: 'Error while generating exif file: ' , resultString ]! !
